void WWVBsync(){
  
  int qdt;
  unsigned long qlastmillis = 0;

  byte frame[60];
  byte fieldIndex=1;
  unsigned int fieldTime;
  unsigned long fieldStart;
  byte fieldValue; 
  byte lastFieldValue;
  bool readingField; //tells if a field is currently being read

  DateTime wwvb;

  bool startGot=0;
  bool timeReady=0;

  Serial.println(F("Waiting for start of minute..."));

  while(1){
    unsigned long tempMillis=millis();
    qdt = millis()-qlastmillis;
    qlastmillis=tempMillis;

    if(readingField){
      if(digitalRead(WWVBpin)==0){fieldTime += qdt;} 
      if(tempMillis-fieldStart>=900){readingField=0;}
    }else{
      if(fieldValue==4){
        fieldIndex++; if(fieldIndex>=60){fieldIndex=0;}
        fieldValue=0; 
        if(fieldTime>=100){fieldValue=1;}
        if(fieldTime>=400){fieldValue=2;}
        if(fieldTime>=700){fieldValue=3;}
        if(lastFieldValue==3&&fieldValue==3){fieldIndex=0;}
        frame[fieldIndex]=fieldValue;
        if(fieldIndex==0){ startGot=1; Serial.println();Serial.print(F("START "));Serial.println();Serial.print(F("  0 1 2 3 4 5 6 7 8 9"));}
        if(fieldIndex%10==0){ Serial.println(); Serial.print(fieldIndex/10); Serial.print(' ');}
        Serial.print(frame[fieldIndex]);Serial.print(' ');
        nixie(fieldIndex, 192);
        /*
        Serial.print(fieldIndex);Serial.print('\t');
        Serial.print(fieldValue);Serial.print('\t');
        Serial.print(lastFieldValue);Serial.print('\t');
        Serial.println(fieldTime);
        */
        if(fieldIndex==59){ //********************************CHECK FRAME*************************************
          byte isvalid = 1;
          byte xhour; byte xminute; int xday; byte xyear;
          Serial.println();
          /*
          Serial.println(F("FRAME TABLE"));
          Serial.print(F("  "));
          for(byte k = 0; k <= 9; k++){Serial.print(k);Serial.print(' ');}
          Serial.println();
          for(byte l = 0; l <= 5; l++){
          Serial.print(l); Serial.print(' ');
          for(byte k = 0; k <= 9; k++){Serial.print(frame[10*l+k]);Serial.print(' ');}
          Serial.println();
          }
          */
          
          if(frame[0]!=3){isvalid=0;} //VALIDITY CHECKS
          if(frame[1]!=1&&frame[1]!=2){isvalid=0;}
          if(frame[2]!=1&&frame[2]!=2){isvalid=0;}
          if(frame[3]!=1&&frame[3]!=2){isvalid=0;}
          if(frame[4]!=1&&frame[4]!=2){isvalid=0;}
          if(frame[5]!=1&&frame[5]!=2){isvalid=0;}
          if(frame[6]!=1&&frame[6]!=2){isvalid=0;}
          if(frame[7]!=1&&frame[7]!=2){isvalid=0;}
          if(frame[8]!=1&&frame[8]!=2){isvalid=0;}
          if(frame[9]!=3){isvalid=0;}
          if(frame[10]!=1&&frame[10]!=2){isvalid=0;}
          if(frame[11]!=1&&frame[11]!=2){isvalid=0;}
          if(frame[12]!=1&&frame[12]!=2){isvalid=0;}
          if(frame[13]!=1&&frame[13]!=2){isvalid=0;}
          if(frame[14]!=1&&frame[14]!=2){isvalid=0;}
          if(frame[15]!=1&&frame[15]!=2){isvalid=0;}
          if(frame[16]!=1&&frame[16]!=2){isvalid=0;}
          if(frame[17]!=1&&frame[17]!=2){isvalid=0;}
          if(frame[18]!=1&&frame[18]!=2){isvalid=0;}
          if(frame[19]!=3){isvalid=0;}
          if(frame[20]!=1&&frame[20]!=2){isvalid=0;}
          if(frame[21]!=1&&frame[21]!=2){isvalid=0;}
          if(frame[22]!=1&&frame[22]!=2){isvalid=0;}
          if(frame[23]!=1&&frame[23]!=2){isvalid=0;}
          if(frame[24]!=1&&frame[24]!=2){isvalid=0;}
          if(frame[25]!=1&&frame[25]!=2){isvalid=0;}
          if(frame[26]!=1&&frame[26]!=2){isvalid=0;}
          if(frame[27]!=1&&frame[27]!=2){isvalid=0;}
          if(frame[28]!=1&&frame[28]!=2){isvalid=0;}
          if(frame[29]!=3){isvalid=0;}
          if(frame[30]!=1&&frame[30]!=2){isvalid=0;}
          if(frame[31]!=1&&frame[31]!=2){isvalid=0;}
          if(frame[32]!=1&&frame[32]!=2){isvalid=0;}
          if(frame[33]!=1&&frame[33]!=2){isvalid=0;}
          if(frame[34]!=1&&frame[34]!=2){isvalid=0;}
          if(frame[35]!=1&&frame[35]!=2){isvalid=0;}
          if(frame[36]!=1&&frame[36]!=2){isvalid=0;}
          if(frame[37]!=1&&frame[37]!=2){isvalid=0;}
          if(frame[38]!=1&&frame[38]!=2){isvalid=0;}
          if(frame[39]!=3){isvalid=0;}
          if(frame[40]!=1&&frame[40]!=2){isvalid=0;}
          if(frame[41]!=1&&frame[41]!=2){isvalid=0;}
          if(frame[42]!=1&&frame[42]!=2){isvalid=0;}
          if(frame[43]!=1&&frame[43]!=2){isvalid=0;}
          if(frame[44]!=1&&frame[44]!=2){isvalid=0;}
          if(frame[45]!=1&&frame[45]!=2){isvalid=0;}
          if(frame[46]!=1&&frame[46]!=2){isvalid=0;}
          if(frame[47]!=1&&frame[47]!=2){isvalid=0;}
          if(frame[48]!=1&&frame[48]!=2){isvalid=0;}
          if(frame[49]!=3){isvalid=0;}
          if(frame[50]!=1&&frame[50]!=2){isvalid=0;}
          if(frame[51]!=1&&frame[51]!=2){isvalid=0;}
          if(frame[52]!=1&&frame[52]!=2){isvalid=0;}
          if(frame[53]!=1&&frame[53]!=2){isvalid=0;}
          if(frame[54]!=1&&frame[54]!=2){isvalid=0;}
          if(frame[55]!=1&&frame[55]!=2){isvalid=0;}
          if(frame[56]!=1&&frame[56]!=2){isvalid=0;}
          if(frame[57]!=1&&frame[57]!=2){isvalid=0;}
          if(frame[58]!=1&&frame[58]!=2){isvalid=0;}
          if(frame[59]!=3){isvalid=0;}
        
          if(!isvalid){Serial.println(F("NF"));}
          
          xminute = 0;
          if(frame[1]==2){xminute+=40;}
          if(frame[2]==2){xminute+=20;}
          if(frame[3]==2){xminute+=10;}
          if(frame[5]==2){xminute+=8;}
          if(frame[6]==2){xminute+=4;}
          if(frame[7]==2){xminute+=2;}
          if(frame[8]==2){xminute+=1;}
          if(xminute>=60){isvalid = 0;}
          xhour = 0;
          if(frame[12]==2){xhour+=20;}
          if(frame[13]==2){xhour+=10;}
          if(frame[15]==2){xhour+=8;}
          if(frame[16]==2){xhour+=4;}
          if(frame[17]==2){xhour+=2;}
          if(frame[18]==2){xhour+=1;}
          if(xhour>=24){isvalid=0;}
          xday = 0;
          if(frame[22]==2){xday+=200;}
          if(frame[23]==2){xday+=100;}
          if(frame[25]==2){xday+=80;}
          if(frame[26]==2){xday+=40;}
          if(frame[27]==2){xday+=20;}
          if(frame[28]==2){xday+=10;}
          if(frame[30]==2){xday+=8;}
          if(frame[31]==2){xday+=4;}
          if(frame[32]==2){xday+=2;}
          if(frame[33]==2){xday+=1;}
          if(xday>=366){isvalid=0;}
          xyear = 0;
          if(frame[45]==2){xyear+=80;}
          if(frame[46]==2){xyear+=40;}
          if(frame[47]==2){xyear+=20;}
          if(frame[48]==2){xyear+=10;}
          if(frame[50]==2){xyear+=8;}
          if(frame[51]==2){xyear+=4;}
          if(frame[52]==2){xyear+=2;}
          if(frame[53]==2){xyear+=1;}
          if(xyear>=100){isvalid=0;}
          if(!isvalid){Serial.println(F("ND"));}
          if(isvalid){
            Serial.print(F("OK "));
            Serial.print(xyear);Serial.print('/');
            Serial.print(xday);Serial.print(' ');
            Serial.print(xhour);Serial.print(':');
            Serial.print(xminute);Serial.println();
            wwvb = DateTime(u1970(xyear,xday,xhour,xminute+1,5));
            Serial.println(F("Will sync on:"));
            Serial.println(wwvb.unixtime());
            Serial.print(wwvb.year());Serial.print('/');
            Serial.print(wwvb.month());Serial.print('/');
            Serial.print(wwvb.day());Serial.print(' ');
            Serial.print(wwvb.hour());Serial.print(':');
            Serial.print(wwvb.minute());Serial.print(':');
            Serial.println(wwvb.second());
            timeReady=1;
          }
        }
        lastFieldValue=fieldValue;
      }
      if(digitalRead(WWVBpin)==0){
        if(fieldIndex==4&&startGot==1&&timeReady==1){break;}  //sync on start of second 5
        readingField=1;
        fieldStart=tempMillis;
        fieldTime=0;
        fieldValue=4;
      }
    }
  }
  rtc.adjust(wwvb);
  Serial.println(F("DONE"));
  
}

long u1970(int y, byte d, byte h, byte m, byte s){ //seconds from given date to 1970, excluding leap
    if (y >= 2000)
        y -= 2000;
    long temp = d;
    temp+= + 365 * y + (y + 3) / 4 - 1;
    temp=temp*24+h;
    temp=temp*60+m;
    temp=temp*60+s;
    return temp+946684800;
}
